/*
 * demo.c
 */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Mrm/MrmPublic.h>

#include "XmpMrm.h"

static void ToggleCb(Widget,XtPointer,XtPointer);
static void ExitCb(Widget,XtPointer,XtPointer);

static MrmHierarchy mrmId;
static MrmCode mrmClass;
static char *mrmFiles[]={"demo.uid"};
static MRMRegisterArg mrmNames[] = {
        {"ToggleCb", (caddr_t)ToggleCb },
        {"ExitCb", (caddr_t)ExitCb },
};

static XtAppContext appContext;
static Display *display;
static Widget shell;
static Widget appMain;

int main(int argc, char** argv)
{
    MrmInitialize();
    XmpMrmInitialize();

    XtToolkitInitialize();
    appContext = XtCreateApplicationContext();
    display = XtOpenDisplay(appContext, NULL, "demo", "Demo", NULL, 0,
						&argc, argv);
    if (display == NULL) {
	fprintf(stderr, "Can't open display\n");
	exit(1);
    }
    shell = XtAppCreateShell("demo", NULL, applicationShellWidgetClass,
						display, NULL, 0);
    if (MrmOpenHierarchy (1, mrmFiles, NULL, &mrmId) != MrmSUCCESS) exit(1);
    MrmRegisterNames(mrmNames, XtNumber(mrmNames));
    MrmFetchWidget (mrmId, "appMain", shell, &appMain, &mrmClass);
    XtManageChild (appMain);
    XtRealizeWidget(shell);
    XtAppMainLoop(appContext);
}


/*
 * ToggleCb
 */
static void ToggleCb(Widget w, XtPointer cd, XtPointer cb)
{
    Widget dialog = XtNameToWidget(shell, (String)cd);
    XmToggleButtonCallbackStruct *tcb = (XmToggleButtonCallbackStruct*)cb;

    if (tcb->set)
	XtManageChild(dialog);
    else
	XtUnmanageChild(dialog);
}


/*
 * ExitCb - Exit application.
 */
static void ExitCb(Widget w, XtPointer cd, XtPointer cb)
{
    exit(0);
}

